%smoothing_example1_sin

Par=[4 8 12];

ToX=.0000001;
range_rho1=10000000;%input('range_rho1; 111-former; ?')
if range_rho1~=111
    range_rho=[0 range_rho1];
end
%erho=@(rh,x,M,si,u)(1/M)*sum(abs(fft(x).*(rh*si)./(rh*si+u)).^2);
%nrho=@(rh,noi,M)(1/M)*sum(abs(fft(noi)).^2);

st1=input('noise std; 111-former; ?')
if st1~=111
    st=st1;
    nois=st*randn(1,2048);
%nois=st*randn(1,2048);
end
k=.01715+(0:1023)*.08/1024;y=sin(1./k);
%g=(0:2047)/2048-1/2;
yy=[fliplr(y) y];
g=[-fliplr(k) k];
figure;
%subplot(2,1,1)
plot(g,yy,'b','Linewidth',2)
axis([.01715, .093, -1.5,1.5]);

figure;
for kk=1:3
    deci=8;
lev=log2(deci);
eval(['subplot(3,2,' int2str(2*kk-1) ')'])
gx=g(1:deci:end);
y=yy(1:deci:end);

noi=nois(1:deci:end);
x=y+noi;
ee=sum(noi(:).^2);
rho=defroPSm(Par(kk),x,ee,range_rho,ToX);
s=smoothsplaPt(x,Par(kk),lev,rho,2) ;
plot(g,s,'r','Linewidth',3);
title(['\fontsize{16}Spl. order: '  int2str(Par(kk)) ', Samp=1:' int2str(deci)])
set(gca,'FontSize',16)
axis([.02, .093,  -1.5,1.7]);
hold on

plot(gx,x,'k+','Linewidth',2)
hold on
plot(g,yy,'--b','Linewidth',2)
end
for kk=1:3
    deci=16;
lev=log2(deci);
eval(['subplot(3,2,' int2str(2*kk) ')'])
gx=g(1:deci:end);
y=yy(1:deci:end);

noi=nois(1:deci:end);
x=y+noi;
ee=sum(noi(:).^2);
rho=defroPSm(Par(kk),x,ee,range_rho,ToX);
s=smoothsplaPt(x,Par(kk),lev,2*rho,2) ;
plot(g,s,'r','Linewidth',3);
title(['\fontsize{16}Spl. order: '  int2str(Par(kk)) ', Samp=1:' int2str(deci)])
set(gca,'FontSize',16)
axis([.02, .093,  -1.5,1.7]);
hold on

plot(gx,x,'k+','Linewidth',2)
hold on
plot(g,yy,'--b','Linewidth',2)
end
